VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Firmware Loader v 0.92"
   ClientHeight    =   3585
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5865
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3585
   ScaleWidth      =   5865
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "COM Port"
      Height          =   855
      Left            =   120
      TabIndex        =   7
      Top             =   1440
      Width           =   1335
      Begin VB.TextBox txtCommPort 
         Height          =   285
         Left            =   720
         TabIndex        =   8
         Text            =   "1"
         Top             =   360
         Width           =   375
      End
      Begin VB.Label Label1 
         Caption         =   "COM"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   375
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Firmware Source (HEX file)"
      Height          =   1215
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   5655
      Begin VB.CommandButton cmdBrowse 
         Caption         =   "Browse"
         Height          =   375
         Left            =   4320
         TabIndex        =   6
         Top             =   720
         Width           =   1215
      End
      Begin VB.TextBox txtFileName 
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   5415
      End
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   5280
      Top             =   1680
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download Firmware"
      Height          =   615
      Left            =   2520
      TabIndex        =   0
      Top             =   1560
      Width           =   2415
   End
   Begin MSComDlg.CommonDialog cd1 
      Left            =   5280
      Top             =   3000
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4680
      Top             =   3000
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InBufferSize    =   1
      InputLen        =   1
      BaudRate        =   19200
   End
   Begin VB.Label Label2 
      Caption         =   "http://www.gogoboard.org"
      Height          =   255
      Left            =   0
      TabIndex        =   10
      Top             =   3360
      Width           =   2055
   End
   Begin VB.Label lblDownloadBarFG 
      BackColor       =   &H00800000&
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   2520
      Width           =   375
   End
   Begin VB.Label lblCurrentBuffer 
      Caption         =   "Current Buffer"
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   2880
      Width           =   5175
   End
   Begin VB.Label lblDownloadBarBG 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   480
      TabIndex        =   1
      Top             =   2520
      Width           =   4935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Dim fso As New Scripting.FileSystemObject
'Dim fls As Scripting.File, fld As Scripting.Folder

'Dim txtStream As TextStream


Dim timeoutFlag As Boolean



Private Sub cmdBrowse_Click()
                ' Open a file dialog and let the user select a HEX file
                cd1.Filter = "Hex Files (*.HEX)|*.HEX| All Files (*.*)|*.*"
                cd1.FilterIndex = 1
                cd1.DialogTitle = "Select a file "

                cd1.ShowOpen
                If cd1.FileName <> "" Then
                    txtFileName.Text = cd1.FileName
                    
                End If

End Sub



Private Sub cmdDownload_Click()
On Error GoTo ErrHandler
    
Dim temp, outBuffer
Dim totalLen, currentLen
Dim fnum As Integer
Dim fileContentLines() As String
Dim i As Long
    
    ' if port already opened then close it
    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
    End If
    
    MSComm1.CommPort = txtCommPort.Text
    
    ' Open the port
    MSComm1.PortOpen = True
    
        If txtFileName.Text <> "" Then
           fnum = FreeFile()
           Open txtFileName.Text For Input As #fnum
           
           ' read each line into fileContentLines() array
           fileContentLines() = Split(Input(LOF(fnum), fnum), vbCrLf)
           Close #fnum
           
           ' remove empty lines + lines not starting with a ":"
           For i = 0 To UBound(fileContentLines)
             If Len(fileContentLines(i)) = 0 Then fileContentLines(i) = vbNullChar
             If Left(fileContentLines(i), 1) <> ":" Then fileContentLines(i) = vbNullChar
           Next
           fileContentLines() = Filter(fileContentLines(), vbNullChar, False)
           
            totalLen = UBound(fileContentLines)
        
        Else
            MsgBox "Error, no HEX file found", vbOKOnly
            Exit Sub
        End If
    
    ' clear the comm port
    MSComm1.InputLen = 0
    temp = MSComm1.Input
    
    'read one byte at a time
    MSComm1.InputLen = 1


    For i = 0 To UBound(fileContentLines)
        
        ' get the next line to be trasmitted
        outBuffer = fileContentLines(i)
        lblCurrentBuffer.Caption = outBuffer
    
        ' update the download status bar
        lblDownloadBarFG.Width = lblDownloadBarBG.Width * (i / totalLen)
    
        ' send the data
        MSComm1.Output = outBuffer
        
        ' wait for a reply byte, which indicates that the board is ready for the next line
        ' Timer 1 prevents infinit loop
        Timer1.Enabled = True
        Do While MSComm1.InBufferCount = 0
            DoEvents
            ' timeoutFlag is set by timer1
            If timeoutFlag = True Then
                MsgBox "Error, board is not ready."
                Timer1.Enabled = False
                timeoutFlag = False
                lblDownloadBarFG.Width = 0
                lblCurrentBuffer = ""
                Exit Sub
            End If
        Loop
        Timer1.Enabled = False
        
        'read the input byte
        temp = Asc(MSComm1.Input)
        
        ' if replay = &H55 then end download
        If temp = &H55 Then
            ' Skip the rest
            GoTo endLoop
        
        ' if replay = &H80 then some of the code in the current HEX file
        ' is overlaping with the bootloader's firmware.
        ElseIf temp = &H80 Then
           Err.Raise 60002, , "HEX file is not compatible with Bootloader. Addresses 0x1E50-0x1FFF cannot be used."
        
        ' the board should send &H11 for every line it recieves
        ElseIf temp <> &H11 Then
            Err.Raise 60001, , "unexpected return byte " & CStr(temp)
            
        End If
        

    Next
    
    
    MsgBox "Warning - Firmware written but there may be problems"
    ' Close the comm port
    MSComm1.PortOpen = False
    
    ' clear the text
    lblCurrentBuffer.Caption = ""
    lblDownloadBarFG.Width = 0
    Exit Sub
    
endLoop:
    
    lblDownloadBarFG.Width = lblDownloadBarBG.Width
    
    MsgBox "Firmware download OK."
    
    ' Close the comm port
    MSComm1.PortOpen = False
    
    ' clear the text
    lblCurrentBuffer.Caption = ""
    lblDownloadBarFG.Width = 0
    
    Exit Sub
    
    
    
ErrHandler:
    MsgBox "Error, " & Err.Description, vbOKOnly
    ' Close the comm port
    MSComm1.PortOpen = False
    ' clear the text
    lblCurrentBuffer.Caption = ""
    lblDownloadBarFG.Width = 0
        

End Sub

Private Sub lblStatus_Click()

End Sub

Private Sub Form_Load()
    lblDownloadBarFG.Width = 0
    timeoutFlag = False
End Sub

Private Sub Timer1_Timer()
    timeoutFlag = True
End Sub
